<?php
/*
Plugin Name: Simple Amazon
Plugin URI: http://www.icoro.com/
Description: ASIN を指定して Amazon から個別商品の情報を取出します。BOOKS, DVD, CD は詳細情報を取り出せます。
Author: icoro
Version: 3.2
Author URI: http://www.icoro.com/
Special Thanks: tomokame (http://http://tomokame.moo.jp/)
Special Thanks: websitepublisher.net (http://www.websitepublisher.net/article/aws-php/)
Special Thanks: hiromasa.zone :o) (http://hiromasa.zone.ne.jp/)
Special Thanks: PEAR :: Package :: Cache_Lite (http://pear.php.net/package/Cache_Lite)
Special Thanks: Amazon® AWS HMAC signed request using PHP (http://mierendo.com/software/aws_signed_query/)
Special Thanks: PHP による Amazon PAAPI の毎秒ルール制限の実装とキャッシュの構築例 (http://sakuratan.biz/archives/1395)
*/

/******************************************************************************
 * simple-amazon-function : amazon ECS search engine
 *****************************************************************************/
if( $_SERVER['SCRIPT_FILENAME'] == __FILE__ ) die();

if ( ! defined( 'SIMPLE_AMAZON_PLUGIN_DIR' ) )
	define( 'SIMPLE_AMAZON_PLUGIN_DIR', WP_PLUGIN_DIR . '/' . plugin_basename( dirname( __FILE__ ) ) );

if ( ! defined( 'SIMPLE_AMAZON_PLUGIN_URL' ) )
	define( 'SIMPLE_AMAZON_PLUGIN_URL', WP_PLUGIN_URL . '/' . plugin_basename( dirname( __FILE__ ) ) );

if ( ! defined( 'SIMPLE_AMAZON_IMG_URL' ) )
	define( 'SIMPLE_AMAZON_IMG_URL', SIMPLE_AMAZON_PLUGIN_URL . '/images' );

$simple_amazon_settings = get_option('simple_amazon_admin_options');


/******************************************************************************
 * THIS FILE IS CALLED ONLY.
 *****************************************************************************/
include_once(SIMPLE_AMAZON_PLUGIN_DIR . '/include/simple-amazon-function.php');


/******************************************************************************
 * 管理画面からオプションを設定
 *****************************************************************************/
class SimpleAmazonAdmin {

	var $simple_amazon_settings, $simple_amazon_options;

	function SimpleAmazonAdmin() {
		if ( !get_option('simple_amazon_admin_options') ){
			// create default options
			$simple_amazon_options = array(
				'associatesid'	=> 'icoro-22',
				'windowtarget'	=> 'self',
				'imgsize'		=> 'medium',
				'layout_type'	=> '0',
				'setcss'		=> 'yes'
			);
			update_option('simple_amazon_admin_options', $simple_amazon_options);
		}
	}

	function simple_amazon_options_page() {

//		global $simple_amazon_settings;

		$simple_amazon_options = get_option('simple_amazon_admin_options');
		$simple_amazon_admin_html =
			'<div class="wrap" id="footnote-options">' . "\n".
			'<h2>Simple Amazon プラグイン設定</h2>' . "\n";

		if ( $_POST['action'] ){
			$simple_amazon_admin_html .= '<div class="updated"><p><strong>設定を保存しました。</strong></p></div>'; 
		}

		switch( $simple_amazon_options['windowtarget']) {
			case newwin: $newwindow = ' checked'; $selfwindow = ''; break;
			case self: $newwindow = ''; $selfwindow = ' checked'; break;
		}

		switch( $simple_amazon_options['imgsize'] ) {
			case small: $s_imgsize = ' checked'; $m_imgsize = ''; $l_imgsize = ''; break;
			case medium: $s_imgsize = ''; $m_imgsize = ' checked'; $l_imgsize = ''; break;
			case large: $s_imgsize = ''; $m_imgsize = ''; $l_imgsize = ' checked'; break;
		}

		switch( $simple_amazon_options['layout_type'] ) {
			case 0: $default_layout  = ' checked';$medium_layout = '';  $simple_layout = ''; $noimage_layout = ''; break;
			case 1: $default_layout = ''; $medium_layout = ' checked'; $simple_layout = ''; $noimage_layout = ''; break;
			case 2: $default_layout  = ''; $medium_layout = ''; $simple_layout = ' checked'; $noimage_layout = ''; break;
			case 3: $default_layout  = ''; $medium_layout = ''; $simple_layout = ''; $noimage_layout = ' checked'; break;
		}

		switch( $simple_amazon_options['setcss']) {
			case yes: $setcss_yes = ' checked'; $setcss_no = ''; break;
			case no: $setcss_yes = ''; $setcss_no = ' checked'; break;
		}
		$simple_amazon_admin_html .=
			'<form method="post" action="' . $_SERVER['PHP_SELF'] . "?" . $_SERVER['QUERY_STRING'] . '">' .
			'<input type="hidden" name="action" value="save_options" />' .
			'<table class="form-table">' .
			'<tr>' . "\n" .
			'<th>あなたのアソシエイト ID</th>' . "\n" .
			'<td><input type="text" name="associatesid" value="' . $simple_amazon_options['associatesid'] . '"  /></td>' . "\n" .
			'</tr>' . "\n" .
			'<tr><th>商品リンクの動作</th>' . "\n" .
			'<td><input type="radio" name="windowtarget" value="self"' . $selfwindow . ' />&nbsp;同じウィンドウ ( target 指定なし )<br />' . "\n" .
			'<input type="radio" name="windowtarget" value="newwin"' . $newwindow . ' />&nbsp;新規ウィンドウ ( target="_blank" )</td>' . "\n" .
			'</tr>' . "\n" .
			'<tr><th>商品詳細の表示項目</th>' . "\n" .
			'<td><input type="radio" name="layout_type" value="0"' . $default_layout . ' />&nbsp;Full ( 画像、タイトル、出版社、発売時期、著者、価格、本のタイプ、ページ数、ISBN、おすすめ度。本以外はこれに準ずる項目 )<br />' . "\n" .
			'<input type="radio" name="layout_type" value="1"' . $medium_layout . ' />&nbsp;Detail ( 画像、タイトル、出版社、著者、発売時期。Fullから価格情報、コード情報、おすすめ度を省略 )<br />' . "\n" .
			'<input type="radio" name="layout_type" value="2"' . $simple_layout . ' />&nbsp;Title &amp; Image ( 画像とタイトルのみ )<br />' . "\n" .
			'<input type="radio" name="layout_type" value="3"' . $noimage_layout . ' />&nbsp;Title ( タイトルのみ )</td>' . "\n" .
			'</tr>' . "\n" .
			'<tr><th>商品画像のサイズ</th>' . "\n" .
			'<td><input type="radio" name="imgsize" value="small"' . $s_imgsize . ' />&nbsp;Small ( 最大 75 x 75px )<br />' . "\n" .
			'<input type="radio" name="imgsize" value="medium"' . $m_imgsize . ' />&nbsp;Medium ( 最大 160 x 160px )<br />' . "\n" .
			'<input type="radio" name="imgsize" value="large"' . $l_imgsize . ' />&nbsp;Large ( 最大 500 x 500px )</td>' . "\n" .
			'</tr>' . "\n" .
			'<tr><th>CSSの読み込み</th>' . "\n" .
			'<td><input type="radio" name="setcss" value="no"' . $setcss_no . ' />&nbsp;style.css ( デフォルトのCSSのみ使用 )<br />' . "\n" .
			'<input type="radio" name="setcss" value="yes"' . $setcss_yes . ' />&nbsp;simple-amazon.css ( Simple Amazon付属のCSSを使用 )</td>' . "\n" .
			'</tr>' . "\n" .
			'</table>' . "\n" .
			'<p class="submit"><input type="submit" name="Submit" value="設定を保存する &raquo;" /></p>' . "\n" .
			'</form>' . "\n" .
			'</div>' . "\n";

			echo $simple_amazon_admin_html;
	}

	function simple_amazon_add_options() {
		// Add a new menu under Options:
		add_options_page(
			'Simple Amazon',
			'Simple Amazon',
			8,
			__FILE__,
			array(&$this, 'simple_amazon_options_page')
		);
	}
	
	function simple_amazon_save_options() {

		global $simple_amazon_settings;

		// create array
		$simple_amazon_options = array(
			'associatesid'	=> $_POST['associatesid'],
			'windowtarget'	=> $_POST['windowtarget'],
			'layout_type'	=> $_POST['layout_type'],
			'imgsize'		=> $_POST['imgsize'],
			'setcss'		=> $_POST['setcss']
		);

		update_option('simple_amazon_admin_options', $simple_amazon_options);
		$options_saved = true;

		//cacheの削除
		$sas = $simple_amazon_settings;
		$sao = $simple_amazon_options;
		$change = false;

		if( $sas['associatesid'] != $sao['associatesid'] )	$change = true;
		if( $sas['imgsize'] != $sao['imgsize'] )			$change = true;
		if( $sas['layout_type'] != $sao['layout_type'] )	$change = true;

		if( $change ) {
			$clearcaches = & new ClearCacheFiles();
			$clearcaches->clear();
		}

	}

}


/******************************************************************************
 * 記事本文中に Amazon から取得した商品情報を表示
 *****************************************************************************/
class SimpleAmazonView {

	/**
	 * The Constructor
	 * 
	 * @param none
	 * @return none
	 */

	function SimpleAmazonView() {
		$this->makedetailview = & new MakeSimpleAmazonHtml();
	}

	/**
	 * 記事本文中のコードを個別商品表示 HTML に置き換える
	 * 
	 * @param $content
	 * @return $transformedstring
	 */
	function _replacestrings($content) { // 記事本文中の呼び出しコードを変換

		global $post;

//		$regexps[] = '/\[tmkm-amazon\](?P<asin>[A-Z0-9]{10,13})\[\/tmkm-amazon\]/';
		$regexps[] = '/<amazon>(?P<asin>[A-Z0-9]{10,13})<\/amazon>/';
		$regexps[] = '/(^|<p>)http:\/\/www.amazon.co.jp\/(?P<name>[\S]+)\/dp\/(?P<asin>[A-Z0-9]{10}).*?($|<\/p>)/m';
		$regexps[] = '/(^|<p>)http:\/\/www.amazon.co.jp\/gp\/product\/(?P<asin>[A-Z0-9]{10}).*?($|<\/p>)/m';
//		$regexps[] = '/^http:\/\/www.amazon.co.jp\/(?P<name>[\S]+)\/dp\/(?P<asin>[A-Z0-9]{10}).*$/m';
//		$regexps[] = '/^http:\/\/www.amazon.co.jp\/gp\/product\/(?P<asin>[A-Z0-9]{10}).*$/m';

//		$transformedstring = $content;

		foreach( $regexps as $regexp ) {
			if( preg_match_all($regexp, $content, $arr) ) {
				for ($i=0; $i<count($arr[0]); $i++) {
//					if( !$arr[name][$i] ) $arr[name][$i] = '';
					$display = $this->makedetailview->format_amazon( $arr[asin][$i], $arr[name][$i] );
					// ASINコードの置換
					$content = str_replace($arr[0][$i], $display, $content);
				}
			}
		}

		/* for WYSWYG Editer */
//		$content = str_replace('<p><div class="simple-amazon-view">', '<div class="simple-amazon-view">', $content);
//		$content = str_replace('<hr class="simple-amazon-clear" /></div></p>', '<hr class="simple-amazon-clear" /></div>', $content);

		return $content;

	}


	/**
	 * PHP 関数として Amazon の個別商品 HTML を呼び出す
	 * 
	 * @param $asin ( ASIN )
	 * @param $type ( book / dvd / cd )
	 * @return echo $display ( HTML )
	 */
	function simple_amazon_view( $asin ) { // PHP テ−マファイル中に記述する関数
		$name = '';
		$display = $this->makedetailview->format_amazon( $asin, $name );
		echo $display;
	}

}


/******************************************************************************
 * Amazon ECS から取得した XML から HTML を生成
 *****************************************************************************/
class MakeSimpleAmazonHtml {

	var $mediumimgfile;
	var $smallimgfile;
	var $largeimgfile;

	var $amazonparse;
	var $generalfunclib;

	function MakeSimpleAmazonHtml() {

		$this->amazonparse = & new GetSimpleAmazonXmlParse();
		$this->generalfunclib = & new CalcISBNLibrary();

	}

	/**
	 * Amazon 商品の HTML ソースを生成
	 * @param $asin ( ASIN )
	 * @param $mediatype ( book / dvd / cd )
	 * @return $output ( HTML )
	 */
	function format_amazon( $asin, $name ) {

		global $simple_amazon_settings;

		/* 初期設定 */
		$this->mediumimgfile = '/amazon_noimg.png';
		$this->smallimgfile = '/amazon_noimg_small.png';
		$this->largeimgfile = '/amazon_noimg_large.png';
		$associatesid = $simple_amazon_settings['associatesid'];
		$layout_type = $simple_amazon_settings['layout_type'];

		switch( $simple_amazon_settings['windowtarget'] ) {
			case newwin: $windowtarget = ' target="_blank"'; break;
			case self: $windowtarget = '';
		}

		/* ISBN13をISBN10に変換 */
		if( strlen( $asin ) == 13 )
			$asin = $this->generalfunclib->calc_chkdgt_isbn10( substr( $asin, 3, 9 ) );

		$output = '';

		/* format typeを設定 */
		if( $layout_type == '1' ) {
			$AmazonXml = $this->amazonparse->getamazonxml( $associatesid, $asin, 'Images,ItemAttributes');
		} elseif( $layout_type == '2' ) {
			$AmazonXml = $this->amazonparse->getamazonxml( $associatesid, $asin, 'Images,Small');
		} elseif( $layout_type == '3' ) {
			$AmazonXml = $this->amazonparse->getamazonxml( $associatesid, $asin, 'Small');
		} else {
			$AmazonXml = $this->amazonparse->getamazonxml( $associatesid, $asin, 'Images,ItemAttributes,Reviews');
//			$AmazonXml = $this->amazonparse->getamazonxml( $associatesid, $asin, 'Medium');
		}

//		DEBUG
/*
		echo "<pre>\n";
		print_r($AmazonXml);
		echo "</pre>\n";
*/

		/* --- Get results of the Amazon function --- */

		// サーバーからリクエストはある?
//		DEBUG
/*
		$AmazonXml = false;
*/
		if( $AmazonXml === false ) {
			$amazonlink = 'http://www.amazon.co.jp/o/ASIN/' . $asin . '/' . $associatesid . '/';
			$amazonimg_url = 'http://images.amazon.com/images/P/' . $asin . '.09.THUMBZZZ.jpg';
			$amazonimg_size = '';

			if( !$name ) $name = "Amazon.co.jpの詳細ページへ &raquo;";

			if( function_exists('getimagesize') ) {
				$imgsize = getimagesize( $amazonimg_url );
//				if( $imgsize[0] == 1 && $imgsize[1] == 1 ) {
				if( $imgsize[0] == 1 ) {
					$amazonimg_url = SIMPLE_AMAZON_IMG_URL . $this->smallimgfile;
					$amazonimg_size = ' width="75" height="75"';
				} else {
					$amazonimg_size = ' ' . $imgsize[3];
				}
			}

			$amazonimg_tag = '<img src="' . $amazonimg_url . '"' . $amazonimg_size . ' class="sa-image" />';

			/* レスポンスがない場合のテンプレート */
//			$output = '<!--Amazonのサーバでエラーが起こっているかもしれません。一度ページを再読み込みしてみてください。-->';
			$output =
				"\n".'<div class="simple-amazon-view">' . "\n" .
				'<p><a href="' . $amazonlink . '">' . $amazonimg_tag . '</a></p>' . "\n" .
				'<p class="sa-title"><a href="' . $amazonlink . '">' . urldecode($name) . '</a></p>' . "\n" .
				'</div>';
			return $output;
		}

		// リクエストは有効?
		if( $AmazonXml->Items->Request->IsValid == 'False' ){
			$output = '<!--与えられたリクエストが正しくありません-->';
			return $output;
		}

		// リクエストを表示
		$item = $AmazonXml->Items->Item;

		$url = $item->DetailPageURL;
		$Title = $item->ItemAttributes->Title;
		$ProductGroup = $item->ItemAttributes->ProductGroup;

		// 画像を設定
		if( $layout_type != '3' ) {
			if($simple_amazon_settings['imgsize'] == 'small') {
				$temp = $item->SmallImage;
				if( !$temp->URL ) {
					$itemimg = SIMPLE_AMAZON_IMG_URL . $this->smallimgfile;
					$itemimgsize = ' height="75" width="75"';
				}
			} elseif($simple_amazon_settings['imgsize'] == 'large') {
				$temp = $item->LargeImage;
				if( !$temp->URL ) {
					$itemimg = SIMPLE_AMAZON_IMG_URL . $this->largeimgfile;
					$itemimgsize = ' height="500" width="500"';
				}
			} else {
				$temp = $item->MediumImage;
				if( !$temp->URL ) {
					$itemimg = SIMPLE_AMAZON_IMG_URL . $this->mediumimgfile;
					$itemimgsize = ' height="160" width="160"';
				}
			}

			if( !$itemimg ) {
				$itemimg = $temp->URL;
				$itemimgsize = ' height="' . $temp->Height . '" width="' . $temp->Width . '"';
			}
		}

		if( $layout_type < 2 ) {
			$Manufacturer = $item->ItemAttributes->Manufacturer;
			$Binding = $item->ItemAttributes->Binding;
			$ReleaseDate = $item->ItemAttributes->ReleaseDate;

			$ASIN = $item->ASIN;
			$EANcode = $item->ItemAttributes->EAN;

			if( $layout_type == 0 ) {
				$Price = $item->ItemAttributes->ListPrice->FormattedPrice;
				$ISBN10 = $item->ItemAttributes->ISBN;

				$rating = $item->CustomerReviews->AverageRating;
				if ($rating) {
					$rating = SIMPLE_AMAZON_IMG_URL . '/stars-' . str_replace('.', '', $rating) . '.gif';
					$rating = '<img src="' . $rating . '" width="64" height="12" alt="" class="sa-rating" />';
				}
			}

			switch( $ProductGroup ){
				case "Book":
					$Role = $item->ItemAttributes;
					$Pages = $item->ItemAttributes->NumberOfPages;
					$Author = $item->ItemAttributes->Author;
					$PublicationDate = $item->ItemAttributes->PublicationDate;
					break;
				case "DVD":
					$RunningTime = $item->ItemAttributes->RunningTime;
					$numofdisc = $item->ItemAttributes->NumberOfDiscs;
					break;
				case "Music":
					$Format = $item->ItemAttributes->Format;
					$Artist = $item->ItemAttributes->Artist;
					break;
			}
		}

		/* テンプレート */

		//Title
		if( $layout_type == 3 ) {
			$output = '<a href="'.$url.'"' . $windowtarget . '>' . $Title . '</a>';
		}

		//Title & Image
		if( $layout_type == 2 ) {
			$output = '<div class="simple-amazon-view">' . "\n";
			$output .= "\t" . '<p><a href="'.$url.'"' . $windowtarget . '><img src="' . $itemimg . '"' . $itemimgsize . ' alt="" class="sa-image" /></a></p>' . "\n";
			$output .= "\t" . '<p class="sa-title"><a href="'.$url.'"' . $windowtarget . '>' . $Title . '</a></p>' . "\n";
//			$output .= '<hr class="simple-amazon-clear" /></div>' . "\n";
			$output .= '</div>' . "\n";
		}

		//Detail
		if( $layout_type == 1 ) {
			$output = '<div class="simple-amazon-view">' . "\n";
			$output .= "\t" . '<p><a href="'.$url.'"' . $windowtarget . '><img src="' . $itemimg . '"' . $itemimgsize . ' alt="" class="sa-image" /></a></p>' . "\n";
			$output .= "\t" . '<p class="sa-title"><a href="'.$url.'"' . $windowtarget . '>' . $Title . '</a></p>' . "\n";

			$output_list = "";

			switch($ProductGroup) {
				case "Book":
					if( $Author !="" ) {
						$output_list .= "\t" ."<li>著者／訳者：";
						if( count($Author) == 1 ) {
							$output_list .= $Author; 
						} else {
							foreach($Author as $auth){ $output_list .= $auth.' '; }
						}
						$output_list .= "</li>\n";
					}
					$output_list .= "\t" . "<li>出版社：$Manufacturer( $PublicationDate )</li>" . "\n";
					$output_list .= "\t" . "<li>" . $Binding . "：$Pages ページ</li>";
					break;
				case "DVD":
					$output_list .= "\t" . "<li>販売元：$Manufacturer( $ReleaseDate )</li>" . "\n";
					$output_list .= "\t" . "<li>時間：$RunningTime 分</li>" . "\n";
					$output_list .= "\t" . "<li>$numofdisc" . " 枚組 ( " . $Binding . " )</li>";
					break;
				case "Music":
					$output_list .= '<li>アーティスト：' . $Artist . "</li>" . "\n";
					$output_list .= "\t" . "<li>レーベル：$Manufacturer( $ReleaseDate )</li>";
					break;
				default:
					if( $ReleaseDate ) $output_list .= "\t" . "<li>発売日：$ReleaseDate</li>";
			}

			if ( $output_list ) {
				$output .= "\t" .'<ul class="sa-detail">' . "\n";
				$output .= $output_list;
				$output .= "\t" . '</ul>' . "\n";
			}

//			$output .= '<hr class="simple-amazon-clear" /></div>' . "\n";
			$output .= '</div>' . "\n";
		}

		//Full
		if( $layout_type < 1 ) {
			$output = '<div class="simple-amazon-view">' . "\n";
			$output .= "\t" . '<p><a href="'.$url.'"' . $windowtarget . '><img src="' . $itemimg . '"' . $itemimgsize . ' alt="" class="sa-image" /></a></p>' . "\n";
			$output .= "\t" . '<p class="sa-title"><a href="'.$url.'"' . $windowtarget . '>' . $Title . '</a></p>' . "\n";

			$output_list = "";

			switch($ProductGroup) {
				case "Book":
					if( $Author !="" ) {
						$output_list .= "\t" ."<li>著者／訳者：";
						if( count($Author) == 1 ) {
							$output_list .= $Author; 
						} else {
							foreach($Author as $auth){ $output_list .= $auth.' '; }
						}
						$output_list .= "</li>\n";
					}
					$output_list .= "\t" . "<li>出版社：$Manufacturer( $PublicationDate )</li>" . "\n";
					$output_list .= "\t" . "<li>" . $Binding . "：$Pages ページ</li>\n";
					$output_list .= "\t" . "<li>ISBN-10 : $ISBN10" . "</li>\n";
					$output_list .= "\t" . "<li>ISBN-13 : $EANcode</li>\n";
					break;
				case "DVD":
					$output_list .= "\t" . "<li>販売元：$Manufacturer( $ReleaseDate )</li>" . "\n";
					$output_list .= "\t" . "<li>時間：$RunningTime 分</li>" . "\n";
					$output_list .= "\t" . "<li>$numofdisc" . " 枚組 ( " . $Binding . " )</li>\n";
					break;
				case "Music":
					$output_list .= '<li>アーティスト：' . $Artist . "</li>" . "\n";
					$output_list .= "\t" . "<li>レーベル：$Manufacturer( $ReleaseDate )</li>\n";
					break;
				default:
					if( $ReleaseDate ) $output_list .= "\t" . "<li>発売日：$ReleaseDate" . "</li>\n";
					$output_list .= "\t" . "<li>カテゴリ：$Binding</li>\n";
			}
			if( $Price ) $output_list .= "\t" . "<li>定価：$Price" . "</li>\n";
			if( $rating ) $output_list .= "\t" . "<li>おすすめ度：$rating</li>\n";

			if ( $output_list ) {
				$output .= "\t" .'<ul class="sa-detail">' . "\n";
				$output .= $output_list;
				$output .= "\t" . '</ul>' . "\n";
			}
//			$output .= '<hr class="simple-amazon-clear" /></div>' . "\n";
			$output .= '</div>' . "\n";
		}

		return $output;
	}

}

if(!function_exists('simple_amazon_view')) {

	function simple_amazon_view($Searchstring) {
		global $simpleAmazonView;
		$simpleAmazonView->simple_amazon_view($Searchstring);
	}

}

function add_simpleamazon_stylesheet(){
	global $simple_amazon_settings;
	if( $simple_amazon_settings['setcss'] == 'yes') {
		?>
<link rel="stylesheet" href="<?php echo SIMPLE_AMAZON_PLUGIN_URL; ?>/simple-amazon.css" type="text/css" media="screen" />
		<?php
	}
}

/******************************************************************************
 * Simple Amazon WordPress Plugin Class & Funtcion Define
 *****************************************************************************/

$simpleAmazonView = & new SimpleAmazonView();
$simpleAmazonAdmin = & new SimpleAmazonAdmin();

add_action('wp_head', 'add_simpleamazon_stylesheet');
add_action('admin_menu', array(&$simpleAmazonAdmin, 'simple_amazon_add_options')); // Insert the Admin panel.
if ( $_POST['action'] == 'save_options' ){
	add_action('admin_menu', array(&$simpleAmazonAdmin, 'simple_amazon_save_options'));
}

add_filter('the_content', array(&$simpleAmazonView, '_replacestrings'));

?>